/*** Makros fuer Fehlerbehandlung             ***/
/*** A.K.Hartmann Januar 1995                 ***/
/*** Version 0.7.0.0 14.6.1996                ***/

/*** Vers-History                                    ***/
/*** 0.6.0.0  extended ldebug-support (descriptions) ***/
/*** 0.7.0.0  TFNE_REMALLOC_AH() added.              ***/

#ifndef _MAKROS_AH_H_
#define _MAKROS_AH_H_

#include <stdio.h>
/*#include <stdlib.h>*/
#include <string.h>

#ifdef _LDEBUG_H_
#define malloc(X) ldebug_malloc(X)
#define free(X) ldebug_free(X)
#define realloc(X, Y) ldebug_realloc(X, Y)


#endif

#define MELDUNG_AH(STRING)  fprintf(stderr, "Achtung: %s \n", STRING);
#define FEHLER_AH(STRING) { fprintf(stderr, "Error: %s \n", STRING); exit(1); }
#define NUMR (2*dim+2)

/* for using this macros the variables dim,next,f,c have to be */
/* (locally) defined !                                         */
#define SOURCE (2*(dim)+1)
#define SINK (2*(dim))
#define INDEX(t, r, d) ((t)*(2*(d)+2)+r)
#define INDEX_SHORT(t, r, d) ((t)*(2*(d)) +r)
#define NEXT(t, r) next[INDEX(t, r, dim)]
#define F(t, r) f[INDEX(t, r, dim)]
#define C(t, r) c[INDEX(t, r, dim)]
#define E(t, r) e[INDEX(t, r, dim)]
#define J(t, r) j[INDEX_SHORT(t, r, dim)]
#define J2(t, r) j2[INDEX_SHORT(t, r, dim)]
#define BOND(t, r) bond[INDEX_SHORT(t, r, dim)]
#define INV_DIR(r) (r - 2*((r) % 2) + 1)  /* 0->1, 1->0, 2->3, 3->2,... */



#ifdef _LDEBUG_H_

#define TF_MALLOC_AH(POINTER,TYPE,STRING) \
{ POINTER = (TYPE *) ldebug_malloc_descr(sizeof(TYPE), STRING); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); }}

#define TFE_MALLOC_AH(POINTER,TYPE,STRING) \
{ POINTER = (TYPE *) ldebug_malloc_descr(sizeof(TYPE), STRING); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); exit(1);}}

#define TFN_MALLOC_AH(POINTER,ANZAHL,TYPE,STRING) \
{ POINTER = (TYPE *) ldebug_malloc_descr((ANZAHL)*sizeof(TYPE), STRING); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); }}

#define TFNE_MALLOC_AH(POINTER,ANZAHL,TYPE,STRING) \
{ POINTER = (TYPE *) ldebug_malloc_descr((ANZAHL)*sizeof(TYPE), STRING); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); exit(1);}}

#define TFNE_REMALLOC_AH(POINTER,ALT_ANZAHL,DELTA,TYPE,STRING) \
{ TYPE * alt = POINTER;\
  POINTER = (TYPE *) ldebug_malloc_descr(((ALT_ANZAHL)+(DELTA))*sizeof(TYPE));\
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); exit(1);}\
  memcpy(POINTER, alt, (ALT_ANZAHL)*sizeof(TYPE)); ldebug_free(alt);}

#else /* _LDEBUG_H_ */

#define TF_MALLOC_AH(POINTER,TYPE,STRING) \
{ POINTER = (TYPE *) malloc(sizeof(TYPE)); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); }}

#define TFE_MALLOC_AH(POINTER,TYPE,STRING) \
{ POINTER = (TYPE *) malloc(sizeof(TYPE)); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); exit(1);}}

#define TFN_MALLOC_AH(POINTER,ANZAHL,TYPE,STRING) \
{ POINTER = (TYPE *) malloc((ANZAHL)*sizeof(TYPE)); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); }}

#define TFNE_MALLOC_AH(POINTER,ANZAHL,TYPE,STRING) \
{ POINTER = (TYPE *) malloc((ANZAHL)*sizeof(TYPE)); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); exit(1);}}

#define TFNE_REMALLOC_AH(POINTER,ALT_ANZAHL,DELTA,TYPE,STRING) \
{ TYPE * alt = POINTER;\
  POINTER = (TYPE *) malloc(((ALT_ANZAHL)+(DELTA))*sizeof(TYPE)); \
  if(POINTER == NULL) \
  {  fprintf(stderr, "Achtung: Kein Speicher fuer %s \n", STRING); exit(1);}\
  memcpy(POINTER, alt, (ALT_ANZAHL)*sizeof(TYPE)); free(alt);}

#endif /* ifdef _LDEBUG_H_ */

#define SEC_TEST(POINTER,MAGIC_NR,STRING) \
{ if(POINTER == NULL) \
  { fprintf(stderr, "Pointer for %s is empty!\n", STRING); exit(1); } \
  else if(POINTER->magic != MAGIC_NR) \
  { fprintf(stderr, "Pointer is not a %s !\n", STRING); exit(1);} }

#endif   /* #ifndef _FEHLER_AH_H_ */














